unit FileHandling;

interface

uses  classes, sysutils, dialogs, comctrls;

Type
  PICDef = ^TICDef;
  TICDef = Record
    Name:String;
    lowadr:Integer;
    highadr:Integer;
  end;
  
  PIO = ^TIO;
  TIO = Record
    Adress:Integer;
    Name:String;
    IOdef:TList
  end;

  PIOPoint = ^TIOPoint;
  TIOPoint = Record
    Output:Boolean;
    Name:String;
    PIN:Integer;
  end;

  xy=TList;

//Procedure LoadIOs1(Filename:String; var Work:TList);
//Function LoadI2Cdef(Filename:String; var Work:TList):Boolean;
Function LoadIOs(Filename:String; var Work:TList):Boolean;
Procedure SaveIOs(Filename:String; IList:TList);
//Function LoadI2Ctest(Filename:String; var Work:TList):Boolean;
Function LoadI2Cdef(Filename:String; var Work:TList):Boolean;

var
  IOs,I2CDef:TLIST;
  I2CDefrec:PICDef;
  IOlist:PIO;

implementation

(*****************************************************************************
*** Name of the Function:
*** Function:              Prottype of reading delimited files
*** Author:                Andreas Hesse
*** Date of construction:  2003-02-03
*** Date of last revision: 2003-02-19
*** Version:               1.0.0.0
*** Comment:
***  ErrorNo:
***   1       end of line inside a field
***   2       did not fid a textdelimiter after an delimiter
***   3       Found too much fields
******************************************************************************
***
*** Version management:
*** V 1.0.0.0  First construction based on
*** *)


Function LoadI2Cdef(Filename:String; var Work:TList):Boolean;
  var delimiter,textdelimiter,CH_read:Char;
      fieldcounter,rowcounter,ij,ix,ErrorNo,LineNo:integer;
      tdelopen,foundfield:Boolean;    //readerror
      strh1,strh2:string;
      F:TextFile;
begin
  delimiter:=',';
  textdelimiter:='"';
  Rowcounter:=0;
  ErrorNo:=0;
  LineNo:=0;
  //readerror:=false;
  tdelopen:=false;
  if Fileexists(Filename) then
  begin
    AssignFile(F, Filename);
    Reset(F);
    while not (Eof(F)) and (ErrorNo=0) do
    begin
      fieldcounter:=0;
      strh1:='';
      strh2:='';
      New(I2CDefrec);
      Inc(LineNo);
      repeat
        read(f,CH_read); (* read one line *)
        strh1:=strh1+CH_Read;
      until (CH_read=chr(10)) or Eof(F);
      if strh1[1]=chr(34) then
        (* Check Read line *)
        For ix:=1 to length(strh1) do
        begin
          if strh1[ix]=Chr(34) then
            if tdelopen then
              tdelopen:=false
            else
              tdelopen:=true;
          if tdelopen then (* collect char for one single field *)
          begin
            if not (strh1[ix] in [delimiter,textdelimiter,chr(13),chr(10)]) then
            begin
              strh2:=strh2+strh1[ix];
              //showmessage(strh2);
            end
            else
              if (strh1[ix] in [chr(13),chr(10)]) then
              (* found end of line with open field *)
              begin
                //readerror:=true;
                ErrorNo:=1;
              end;
          end
          else (* not tdelopen
                    It should occur: next sign is a chr(13) -> dataset end
                    or  delimiter -> next field *)
            if strh1[ix]<>chr(10) then
            if (strh1[ix+1]=Chr(13)) or (strh1[ix+1]=Chr(0))  then
            Begin (* next datarow *)
              rowcounter:=rowcounter+1;
              //showmessage(inttostr(ord(strh1[ix+1])));
              fieldcounter:=fieldcounter+1;
              foundfield:=true;
            end
            else
              if strh1[ix+1]=delimiter then
              (* next field *)
              begin
                fieldcounter:=fieldcounter+1;
                foundfield:=true;
              end
              else  (* error *)
                If not (strh1[ix]=delimiter) and (strh1[ix+1]=chr(34)) then
                begin
                  //readerror:=true;
                  ErrorNo:=2;
                end;
            if foundfield and (ErrorNo=0) then
            begin
              case fieldcounter of
                1 : Begin
                      //showmessage(strh2);
                      I2CDefrec^.Name:=strh2
                    end;
                2 : Begin
                      if TryStrToInt(strh2,ij) then
                        I2CDefrec^.lowadr:=strtoint(strh2)
                      else
                        I2CDefrec^.lowadr:=0;
                    end;
                3 : Begin
                      if TryStrToInt(strh2,ij) then
                        I2CDefrec^.Highadr:=strtoint(strh2)
                      else
                        I2CDefrec^.Highadr:=0;
                      Work.Add(I2CDefrec);
                      //showmessage(I2CDefrec.Name+':'+inttostr(I2CDefrec.lowadr)+'-'+inttostr(I2CDefrec.highadr));
                    end;
                 4 : Begin
                       ErrorNo:=3;
                     end;
                end;   (* Case *) {}
              //showmessage(strh2);
              strh2:='';
              foundfield:=false;
            end;    (* if not read error *)
        end; (* of for ix-...*)
    end;
    CloseFile(F)
  end
  else
     showmessage(Filename + ' ist nicht vorhanden!');
  If (ErrorNo>0) then
    Showmessage('Es trat der Fehler Nr. '+inttostr(errorNo)+#13#10+
    'beim Lesen von '+#13#10+filename+' auf!'
    + #13#10+' (Zeile: '+inttostr(LineNo)+')');
end;

Function LoadIOs(Filename:String; var Work:TList):Boolean;
   var delimiter,textdelimiter,CH_read:Char;
      fieldcounter,rowcounter,ij,ix,ErrorNo,LineNo:integer;
      tdelopen,foundfield:Boolean;    //readerror
      strh1,strh2:string;
      F:TextFile;
begin
  delimiter:=',';
  textdelimiter:='"';
  Rowcounter:=0;
  ErrorNo:=0;
  LineNo:=0;
  //readerror:=false;
  tdelopen:=false;
  if Fileexists(Filename) then
  begin
    AssignFile(F, Filename);
    Reset(F);
    while not (Eof(F)) and (ErrorNo=0) do
    begin
      fieldcounter:=0;
      strh1:='';
      strh2:='';
      New(IOlist);
      Inc(LineNo);
      repeat
        read(f,CH_read); (* read one line *)
        strh1:=strh1+CH_Read;
      until (CH_read=chr(10)) or Eof(F);
      if strh1[1]=chr(34) then
        (* Check Read line *)
        For ix:=1 to length(strh1) do
        begin
          if strh1[ix]=Chr(34) then
            if tdelopen then
              tdelopen:=false
            else
              tdelopen:=true;
          if tdelopen then (* collect char for one single field *)
          begin
            if not (strh1[ix] in [delimiter,textdelimiter,chr(13),chr(10)]) then
            begin
              strh2:=strh2+strh1[ix];
              //showmessage(strh2);
            end
            else
              if (strh1[ix] in [chr(13),chr(10)]) then
              (* found end of line with open field *)
              begin
                //readerror:=true;
                ErrorNo:=1;
              end;
          end
          else (* not tdelopen
                    It should occur: next sign is a chr(13) -> dataset end
                    or  delimiter -> next field *)
            if strh1[ix]<>chr(10) then
            if (strh1[ix+1]=Chr(13)) or (strh1[ix+1]=Chr(0))  then
            Begin (* next datarow *)
              rowcounter:=rowcounter+1;
              //showmessage(inttostr(ord(strh1[ix+1])));
              fieldcounter:=fieldcounter+1;
              foundfield:=true;
            end
            else
              if strh1[ix+1]=delimiter then
              (* next field *)
              begin
                fieldcounter:=fieldcounter+1;
                foundfield:=true;
              end
              else  (* error *)
                If not (strh1[ix]=delimiter) and (strh1[ix+1]=chr(34)) then
                begin
                  //readerror:=true;
                  ErrorNo:=2;
                end;
            if foundfield and (ErrorNo=0) then
            begin
              case fieldcounter of
                1 : Begin
                     //showmessage(strh2);
                      IOlist^.Adress:=strtoint(strh2)
                    end;
                2 : Begin
                      IOlist^.Name:=StrH2;
                      Work.Add(IOlist);
                    end;
                {3 : Begin
                      if TryStrToInt(strh2,ij) then
                        I2CDefrec^.Highadr:=strtoint(strh2)
                      else
                        I2CDefrec^.Highadr:=0;

                      //showmessage(I2CDefrec.Name+':'+inttostr(I2CDefrec.lowadr)+'-'+inttostr(I2CDefrec.highadr));
                    end;
                 4 : Begin
                       ErrorNo:=3;
                     end;    }
                end;   (* Case *) {}
              //showmessage(strh2);
              strh2:='';
              foundfield:=false;
            end;    (* if not read error *)
        end; (* of for ix-...*)
    end;
    CloseFile(F)
  end
  else
     showmessage(Filename + ' ist nicht vorhanden!');
  If (ErrorNo>0) then
    Showmessage('Es trat der Fehler Nr. '+inttostr(errorNo)+#13#10+
    'beim Lesen von '+#13#10+filename+' auf!'
    + #13#10+' (Zeile: '+inttostr(LineNo)+')');
end;



{Procedure LoadIOs1(Filename:String; var Work:TList);
  var delimiter,textdelimiter,CH_read,lastchar:Char;
      fieldcounter,rowcounter,ij:integer;
      tdelopen,tdelclose,tdelerror,readstart,readerror:Boolean;
      strh1:string;
      F:TextFile;
begin
  delimiter:=',';
  textdelimiter:='"';
  Rowcounter:=0;
  lastchar:=chr(0);
  if Fileexists(Filename) then
  begin
    AssignFile(F, Filename);
    Reset(F);
    while not (Eof(F)) do
    begin
      fieldcounter:=0;
      //New(IOlist);
      repeat
        strh1:='';
        readstart:=true;
        repeat
          read(f,CH_read);
          //showmessage(inttostr(ord(ch_read)));
          if readstart and not (CH_read=textdelimiter) then
             readerror:=true
          else
            readstart:=false;
          if CH_read=textdelimiter then
            if tdelopen then
            begin
              tdelclose:=true;
              tdelopen:=false;
            end
            ELSE
              Begin
                tdelclose:=false;
                tdelopen:=true;
              end;
          if (CH_read=delimiter) and not tdelclose then
            tdelerror:=true;
          if not (CH_read in [delimiter,textdelimiter,chr(13),chr(10)]) then
          begin
            strh1:=strh1+CH_read;
            //lastchar:=CH_read;
          end
        until (CH_read=delimiter) or (CH_read=chr(13)) or Eof(F) or readerror
              or tdelerror;
        //showmessage(strh1);
        fieldcounter:=fieldcounter+1;
        if not (readerror or tdelerror) then
          case fieldcounter of
          1 : Begin
                //if strtointdef(strh1,ij) then
               //showmessage(strh1);
                  //IOlist^.Adress:=strtoint(strh1)
                //else
                //  IOlist^.Adress:=-1;

              end;
          2 : Begin
               // IOlist^.Name:=StrH1;
                //IOdef:TList
                //IOs.Add(IOlist)
              end
        end   // Case
      until (CH_read=chr(13)) or (CH_read=chr(10)) or Eof(F)or readerror
              or tdelerror;
      rowcounter:=rowcounter+1;
      //Dispose(IOList);
    end;
    CloseFile(F)
  end
  else
     showmessage(Filename + ' ist nicht vorhanden!');
end;       {}

Procedure SaveIOs(Filename:String; IList:TList);
   var delimiter,textdelimiter,CH_read,lastchar:Char;
      fieldcounter,rowcounter,ij:integer;
      strh1,x:string;
      F:TextFile;
      actitem:TListItems;
begin
  AssignFile(F, Filename);
  Rewrite(F);
 // For ij:=0 to FO_I2C.LV_IO1.count-1 do
  begin
    //actitem:=LV_IO1.items[ij];
    //strh1:='"'+inttostr(ij)+","+LV_IO1.subitems[Test"'; //+Inttostr(IOlist^.Adress)+'","'+IOlist^.Name+'"';
    writeln(f,strh1);
  end;
  CloseFile(F)
 // else
   //  showmessage(Filename + ' ist nicht vorhanden!');
end;

 {
Function LoadI2Ctest(Filename:String; var Work:TList):Boolean;
  var delimiter,textdelimiter,CH_read,lastchar:Char;
      fieldcounter,rowcounter,ij:integer;
      tdelopen,tdelclose,tdelerror,readstart,readerror,comment:Boolean;
      strh1:string;
      F:TextFile;
begin
  delimiter:=',';
  textdelimiter:='"';
  Rowcounter:=0;
  lastchar:=chr(0);
  readerror:=false;
  tdelerror:=false;
  tdelopen:=false;
  if Fileexists(Filename) then
  begin
    AssignFile(F, Filename);
    Reset(F);
    while not (Eof(F)) do
    begin
      fieldcounter:=0;
      New(I2CDefrec);
      repeat
        strh1:='';
        readstart:=true;
        comment:=false;
        repeat
          read(f,CH_read);
          //showmessage(inttostr(ord(ch_read)));
          if readstart and not (CH_read=textdelimiter) then
          begin
            if CH_Read=Chr(10) then
            (* Must be handled when the second and ... dataset will be loaded *)
            begin
              if not eof(f) then
                read(f,CH_read); (* read the chr(10) at the end of line *)
                if CH_Read=textdelimiter then
                  readstart:=false
                else
                  readerror:=false
            end   (* CH_read=Chr(10) *)
            else
              if CH_Read=';' then
                comment:=True
              else
                readerror:=true;
             //showmessage('Readerror:' + inttostr(ord(ch_read)));
          end
          else
            readstart:=false;
          if CH_read=textdelimiter then
            if tdelopen then
            begin
              tdelclose:=true;
              tdelopen:=false;
            end
            ELSE
              Begin
                tdelclose:=false;
                tdelopen:=true;
              end;
          if (CH_read=delimiter) and not tdelclose then
          begin
            tdelerror:=true;
            showmessage('Textdelimitererror'+inttostr(ord(ch_read)));
          end;
          if not (CH_read in [delimiter,textdelimiter,chr(13),chr(10)]) then
          begin
            strh1:=strh1+CH_read;
            //showmessage(strh1);
            //lastchar:=CH_read;
          end;
        until (CH_read=delimiter) or (CH_read=chr(13)) or Eof(F) or readerror
              or tdelerror;
        //showmessage(strh1);
        fieldcounter:=fieldcounter+1;
        if not (readerror or tdelerror) then
          case fieldcounter of
          1 : Begin
                I2CDefrec^.Name:=strh1
              end;
          2 : Begin
                I2CDefrec^.lowadr:=strtoint(strh1);
              end;
          3 : Begin
                I2CDefrec^.Highadr:=strtoint(strh1);
              end
        end   (* Case *)
      until (CH_read=chr(13)) or (CH_read=chr(10)) or Eof(F)or readerror
              or tdelerror;
      Work.Add(I2CDefrec);
      rowcounter:=rowcounter+1;
      //Dispose(I2CDefrec);
    end;
    CloseFile(F)
  end
  else
     showmessage(Filename + ' ist nicht vorhanden!');
end;

Function LoadI2Cdef(Filename:String; var Work:TList):Boolean;
  var delimiter,textdelimiter,CH_read,lastchar:Char;
      fieldcounter,rowcounter,ij:integer;
      tdelopen,tdelclose,tdelerror,readstart,readerror:Boolean;
      strh1:string;
      F:TextFile;
      //x:array [] of char;
begin
  delimiter:=',';
  textdelimiter:='"';
  Rowcounter:=0;
  lastchar:=chr(0);
   if Fileexists(Filename) then          //Dialog zum Dateiffnen anzeigen
  begin
    AssignFile(F, Filename);   //Datei ausgewhlt
    Reset(F);
    while not (Eof(F)) do
    begin
      fieldcounter:=0;
      New(I2CDefrec);
      repeat
        strh1:='';
        repeat
          read(f,CH_read);
          //if ch_read=chr(10) then showmessage(inttostr(ord(ch_read)));
          if not (CH_read in [delimiter,textdelimiter,chr(13),chr(10)]) then
          begin
            strh1:=strh1+CH_read;
            lastchar:=CH_read;
          end;
          //If (ch_read=Chr(10)) or (EOF(f)) then work.Add(I2CDefrec)
        until (CH_read=delimiter) or (CH_read=chr(13)) or Eof(F);
        //showmessage(strh1);
        fieldcounter:=fieldcounter+1;
        case fieldcounter of
          1 : Begin
                I2CDefrec^.Name:=strh1
              end;
          2 : Begin
                I2CDefrec^.lowadr:=strtoint(strh1);
              end;
          3 : Begin
                I2CDefrec^.Highadr:=strtoint(strh1);
              end
        end   // Case
       until (CH_read=chr(13)) or Eof(F);
       work.Add(I2CDefrec);
       rowcounter:=rowcounter+1;  
    end;
    CloseFile(F);
  end
  else
  	showmessage(Filename + ' ist nicht vorhanden!');
end;


{}
end.
