unit I2CDisplay;

interface

Type
 TDisplayChar = Record
    part1:Byte;
    part2:Byte
  end;

var
  DisplayChar:Array [0..140] of TDisplayChar;

Procedure SetDisplayChars;

implementation

Procedure SetDisplayChars;
Begin
  (* Table of Chardefinitions:
      x means: Char is not good readable *)
  DisplayChar[0].part1:=0;
  DisplayChar[0].part2:=0;
  DisplayChar[1].part1:=1;    (* 001h, 020h ; ! XXX*)
  DisplayChar[1].part2:=32;
  DisplayChar[2].part1:=128;  (* 080h, 020h ; " *)
  DisplayChar[2].part2:=32;
  DisplayChar[3].part1:=37;   (* 025h, 03dh ; # XXX *)
  DisplayChar[3].part2:=61;
  DisplayChar[4].part1:=0;    (* 0adh, 0b5h ; $ X *)
  DisplayChar[4].part2:=0;
  DisplayChar[5].part1:=0;    (* 0ech, 037h ; % X  *)
  DisplayChar[5].part2:=55;
  DisplayChar[6].part1:=59;   (* 03bh, 071h ; & XXX  *)
  DisplayChar[6].part2:=113;
  DisplayChar[7].part1:=0;    (* 000h, 002h ; ' *)
  DisplayChar[7].part2:=2;
  DisplayChar[8].part1:=0;    (* 000h, 042h ; ( *)
  DisplayChar[8].part2:=66;
  DisplayChar[9].part1:=66;   (* 042h, 000h ; ) *)
  DisplayChar[9].part2:=0;
  DisplayChar[10].part1:=102; (* 066h, 066h ; *  *)
  DisplayChar[10].part2:=102;
  DisplayChar[11].part1:=36;  (* 024h, 024h ; +  *)
  DisplayChar[11].part2:=36;
  DisplayChar[12].part1:=64;  (* 040h, 000h ; ,  *)
  DisplayChar[12].part2:=0;
  DisplayChar[13].part1:=32;  (* 020h, 004h ; -  *)
  DisplayChar[13].part2:=4;
  DisplayChar[14].part1:=1;   (* 001h, 000h ; .  *)
  DisplayChar[14].part2:=0;
  DisplayChar[15].part1:=64;  (* 040h, 002h ; /   *)
  DisplayChar[15].part2:=2;
  DisplayChar[16].part1:=153; (* 099h, 099h ; 0 gleich dem O    *)
  DisplayChar[16].part2:=153;
  DisplayChar[17].part1:=0;   (* 000h, 009h ; 1  *)
  DisplayChar[17].part2:=9;
  DisplayChar[18].part1:=57;  (* 039h, 09Ch ; 2  57,156 *)
  DisplayChar[18].part2:=156;
  DisplayChar[19].part1:=41;  (* 029h, 09Dh ; 3   *)
  DisplayChar[19].part2:=157;
  DisplayChar[20].part1:=160; (* 0A0h, 00Dh ; 4  *)
  DisplayChar[20].part2:=13;
  DisplayChar[21].part1:=169; (* 0A9h, 095h ; 5  *)
  DisplayChar[21].part2:=149;
  DisplayChar[22].part1:=185; (* 0B9h, 095h ; 6  *)
  DisplayChar[22].part2:=149;
  DisplayChar[23].part1:=8;   (* 008h, 089h ; 7 *)
  DisplayChar[23].part2:=137;
  DisplayChar[24].part1:=185; (* 0B9h, 09Dh ; 8  *)
  DisplayChar[24].part2:=157;
  DisplayChar[25].part1:=169; (* 0A9h, 09Dh ; 9 *)
  DisplayChar[25].part2:=157;
  DisplayChar[26].part1:=40;  (* 028h, 000h ; : XXX  *)
  DisplayChar[26].part2:=0;
  DisplayChar[27].part1:=72;  (* 048h, 000h ; ; XXX  *)
  DisplayChar[27].part2:=0;
  DisplayChar[28].part1:=65;  (* 041h, 012h ; < XX  *)
  DisplayChar[28].part2:=18;
  DisplayChar[29].part1:=33;  (* 021h, 014h ; = XXX  *)
  DisplayChar[29].part2:=0;
  DisplayChar[30].part1:=3;   (* 003h, 050h ; > XX  *)
  DisplayChar[30].part2:=74;
  DisplayChar[31].part1:=140; (* 08ch, 08ch ; ? *)
  DisplayChar[31].part2:=140;
  DisplayChar[32].part1:=61;  (* 03dh, 099h ; @  *)
  DisplayChar[32].part2:=153;
  DisplayChar[33].part1:=184; (* 0b8h, 08dh ; A  *)
  DisplayChar[33].part2:=141;
  DisplayChar[34].part1:=13;  (* 00dh, 0bdh ; B  *)
  DisplayChar[34].part2:=189;
  DisplayChar[35].part1:=153; (* 099h, 090h ; C  *)
  DisplayChar[35].part2:=144;
  DisplayChar[36].part1:=13;  (* 00dh, 0b9h ; D  *)
  DisplayChar[36].part2:=185;
  DisplayChar[37].part1:=185; (* 0b9h, 094h ; E  *)
  DisplayChar[37].part2:=148;
  DisplayChar[38].part1:=184; (* 0b8h, 080h ; F  *)
  DisplayChar[38].part2:=128;
  DisplayChar[39].part1:=153; (* 099h, 095h ; G  *)
  DisplayChar[39].part2:=149;
  DisplayChar[40].part1:=176; (* 0b0h, 00dh ; H  *)
  DisplayChar[40].part2:=13;
  DisplayChar[41].part1:=13;  (* 00dh, 0b0h ; I  *)
  DisplayChar[41].part2:=176;
  DisplayChar[42].part1:=29;  (* 01dh, 0a0h ; J  *)
  DisplayChar[42].part2:=160;
  DisplayChar[43].part1:=176; (* 0b0h, 042h ; K  *)
  DisplayChar[43].part2:=66;
  DisplayChar[44].part1:=145; (* 091h, 010h ; L  *)
  DisplayChar[44].part2:=16;
  DisplayChar[45].part1:=146; (* 092h, 00bh ; M  *)
  DisplayChar[45].part2:=11;
  DisplayChar[46].part1:=146; (* 092h, 049h ; N  *)
  DisplayChar[46].part2:=73;
  DisplayChar[47].part1:=153; (* 099h, 099h ; O   *)
  DisplayChar[47].part2:=153;
  DisplayChar[48].part1:=184; (* 0b8h, 08ch ; P   *)
  DisplayChar[48].part2:=0;
  DisplayChar[49].part1:=153; (* 099h, 0d9h ; Q  *)
  DisplayChar[49].part2:=217;
  DisplayChar[50].part1:=184; (* 0b8h, 0cch ; R *)
  DisplayChar[50].part2:=204;
  DisplayChar[51].part1:=169; (* 0a9h, 095h ; S   *)
  DisplayChar[51].part2:=149;
  DisplayChar[52].part1:=12;  (* 00ch, 0a0h ; T  *)
  DisplayChar[52].part2:=160;
  DisplayChar[53].part1:=145; (* 091h, 019h ; U  *)
  DisplayChar[53].part2:=25;
  DisplayChar[54].part1:=208; (* 0d0h, 002h ; V *)
  DisplayChar[54].part2:=2;
  DisplayChar[55].part1:=208; (* 0d0h, 049h ; W  *)
  DisplayChar[55].part2:=73;
  DisplayChar[56].part1:=66;  (* 042h, 042h ; X  *)
  DisplayChar[56].part2:=66;
  DisplayChar[57].part1:=6;   (* 006h, 002h ; Y  *)
  DisplayChar[57].part2:=2;
  DisplayChar[58].part1:=73;  (* 049h, 092h ; Z *)
  DisplayChar[58].part2:=146;
  DisplayChar[59].part1:=153; (* 099h, 000h ; [  *)
  DisplayChar[59].part2:=0;
  DisplayChar[60].part1:=2;   (* 002h, 040h ; \  *)
  DisplayChar[60].part2:=64;
  DisplayChar[61].part1:=0;   (* 000h, 099h ; ]  *)
  DisplayChar[61].part2:=153;
  DisplayChar[62].part1:=64;  (* 040h, 040h ; ^ XXX  *)
  DisplayChar[62].part2:=64;
  DisplayChar[63].part1:=1;   (* 001h, 010h ; _  *)
  DisplayChar[63].part2:=16;
  DisplayChar[64].part1:=0;  (*   *)
  DisplayChar[64].part2:=0;
  DisplayChar[65].part1:=0;  (*   *)
  DisplayChar[65].part2:=0;

  (*
    alternative small numbers:
    09dh, 020h ; 0
    004h, 020h ; 1
    039h, 020h ; 2
    02dh, 020h ; 3
    0a4h, 020h ; 4
    0adh, 000h ; 5
    0bdh, 000h ; 6
    00ch, 020h ; 7
    0bdh, 020h ; 8
    0adh, 020h ; 9
  *)

end;

end.
